package main

import (
	"sync"

	"github.com/go-kit/log/level"
	"tildegit.org/tjp/sliderule/logging"
)

var (
	once                      sync.Once
	debug, info, warn, errlog logging.Logger
)

func BaseLogger(config *Configuration) logging.Logger {
	return level.NewFilter(logging.Base(), level.Allow(config.LogLevel))
}

func Loggers(config *Configuration) (logging.Logger, logging.Logger, logging.Logger, logging.Logger) {
	base := BaseLogger(config)
	return level.Debug(base), level.Info(base), level.Warn(base), level.Error(base)
}
